<template lang="pug">
mixin info(name)
  .col-12.text-left.col-sm-3.col-lg-4
    strong= name
  .col-12.text-right.col-sm-9.col-lg-8.text-sm-left
    block

mixin badge(cond, name)
  div
    .badge.badge-primary.shadow-sm.mr-1(v-if=cond) ON
    .badge.badge-secondary.shadow-sm.mr-1(v-else) OFF
    span.text-muted= name

mixin alert
  .alert.small.px-1.py-0.my-2&attributes(attributes)
    block

BaseCard(title='Sample Exchanger')
  template(v-slot:header='')
    .d-flex.justify-content-between.align-items-center
      h5 Sample Exchanger
      .ml-1
        i.fa.fa-circle.text-success.x-blinker(:class='{ blink: blink }' title='updated')
      .ml-auto.b-clickable(@click='inEdit = true' v-if='!inEdit')
        kbd.keyHint.mr-2(v-if="showKeyHints") E
        i.fa.fa-cog
      .ml-auto.b-clickable(@click='inEdit = false' v-else)
        kbd.keyHint.mr-2(v-if="showKeyHints") Esc
        i.fa.fa-times
  li(v-if='Acquisition && Status' key='Acquisition')
    .row
      .col-12
        input.form-control-range(type='range'
          @change='moveTo($event.target.value)'
          :min='Acquisition.actualPosition_min' :max='Acquisition.actualPosition_max'
          :value='Acquisition.actualPosition' :title='Acquisition.actualPosition')
      .col-4.content-center.d-flex.justify-content-center
        +badge('Acquisition.cwSwitch', 'CW switch (-)')
      .col-4.content-center.d-flex.justify-content-center
        +badge('Acquisition.homeSwitch', 'Home switch')
      .col-4.content-center.d-flex.justify-content-center
        +badge('Acquisition.ccwSwitch', 'CCW switch (+)')
  li(v-if='Acquisition && Status' key='AcquisitionState')
    .row
      +info('Position') {{Acquisition.actualPosition | b-bigNumber('', { precision: 3 })}} {{Acquisition.actualPosition_units}}
      +info('Named Position') {{Acquisition.positionName}} #[span.text-muted ({{Acquisition.positionNumber}})]
      +info('State')
        .badge.badge-success.shadow-sm(v-if='Acquisition.state === $options.AxisState.STEADY') {{toStateName(Acquisition.state)}}
        .badge.badge-warning.shadow-sm(v-else) {{toStateName(Acquisition.state)}}
      +info('Driver')
        .badge.badge-success.shadow-sm(v-if='!Status.offline') ONLINE
        .badge.badge-danger.shadow-sm(v-else) OFFLINE
      BaseAnimationGroup.col-12.m-0.b-alerts(:appear='true' anim='height')
        +alert.alert-info()(v-if='Acquisition.homing' key='homing')
          | #[.fa.fa-cog] homing in progress
        +alert.alert-danger()(v-for='(errorMessage, idx) in Status.errorMessages' :key="'b-drv-' + idx" )
          | #[strong error: ] {{ errorMessage }}
  li(key='Ctrl' v-if='Acquisition && ExpertSetting')
    .row
      +info("Absolute Position")
        .d-flex
          BaseInput.flex-grow-1(ref='absMove'
            @keydown.native.enter='moveTo(absTarget)'
            @edit='$refs.absMove.checkValidity()'
            :min='Acquisition.actualPosition_min' :max='Acquisition.actualPosition_max'
            :inEdit='true' type='number' v-model='absTarget')
          div.my-auto(v-if='!$butils.isEmpty(absTarget)')
            button.btn.btn-sm.btn-primary.shadow-sm(@click='moveTo(absTarget)') #[i.fa.fa-play]
      +info("Relative Position")
        .d-flex
          BaseInput.flex-grow-1(
            @keydown.native.enter='moveOf(relTarget)'
            :inEdit='true' type='number' v-model='relTarget')
          div.my-auto(v-if='!$butils.isEmpty(relTarget)')
            button.btn.btn-sm.btn-primary.shadow-sm(@click='moveOf(relTarget)') #[i.fa.fa-play]
      +info('Predefined Position')
        .d-flex
          BaseSelect(:value='Acquisition.positionNumber' :inEdit='true'
              @edit='predefTarget = Number($event)'
              @keydown.native.enter='movePredefined(predefTarget)')
            template(v-slot:options='')
              option(value='-1')
              option(v-for='(name, idx) in ExpertSetting.predefinedPositionsNames' :value='idx') {{ name }}
          div.my-auto(v-if='predefTarget !== Acquisition.positionNumber && predefTarget >= 0')
            button.btn.btn-sm.btn-primary.shadow-sm(@click='movePredefined(predefTarget)') #[i.fa.fa-play]
      +info("Homing")
        .d-flex.justify-content-center.my-1
          button.btn.btn-sm.btn-primary.shadow-sm(@click='runHoming()') #[i.fa.fa-step-forward.fa-rotate-90]
      +info("Stop")
        .d-flex.justify-content-center.my-1
          button.btn.btn-sm.btn-danger.shadow-sm(@click='stop()') #[i.fa.fa-stop]
  li(key='Predefined' v-if='inEdit')
    .row
      .col-12 #[strong Predefined Position (edit)]
      PositionEdit(@updated='inEdit = false')
</template>

<script src='./Controller.vue.js' />
<style>
.x-blinker.blink {
  opacity: 0;
  animation: blink .250s;
}
.x-blinker:not(.blink) {
  opacity: 0;
  animation: blinker .250s;
}

@keyframes blinker {
  0% {
    opacity: 0;
  }
  50% {
    opacity: 1;
  }
  100% {
    opacity: 0;
  }
}

@keyframes blink {
  0% { opacity: 0; }
  50% { opacity: 1; }
  100% { opacity: 0; }
}

</style>
